//wave

//https://www.shadertoy.com/view/4dS3Wd
highp float hash_cloud(highp vec2 p) {vec3 p3 = fract(vec3(p.xyx) * 0.13); p3 += dot(p3, p3.yzx + 6.666); return fract((p3.x + p3.y) * p3.z); }

highp float cloudnoise(highp vec2 x) {
    highp vec2 i = floor(x);
    highp vec2 f = fract(x);

	// Four corners in 2D of a tile
	highp float a = hash_cloud(i);
    highp float b = hash_cloud(i + vec2(1.0, 0.0));
    highp float c = hash_cloud(i + vec2(0.0, 1.0));
    highp float d = hash_cloud(i + vec2(1.0, 1.0));

    // Simple 2D lerp using smoothstep envelope between the values.
	// return vec3(mix(mix(a, b, smoothstep(0.0, 1.0, f.x)),
	//			mix(c, d, smoothstep(0.0, 1.0, f.x)),
	//			smoothstep(0.0, 1.0, f.y)));

	// Same code, with the clamps in smoothstep and common subexpressions
	// optimized away.
    highp vec2 u = f * f * (3.0 - 2.0 * f);
	return mix(a, b, u.x) + (c - a) * u.y * (1.0 - u.x) + (d - b) * u.x * u.y;
}

//https://github.com/ashima/webgl-noise/blob/master/src/noise2D.glsl
highp vec3 mod289(highp vec3 x){return x-floor(x*(1./289.))*289.;}
highp vec2 mod289(highp vec2 x){return x-floor(x*(1./289.))*289.;}
highp vec3 permute(highp vec3 x){return mod289(((x*34.)+1.)*x);}
highp float gnoise(highp vec2 v){const highp vec4 C=vec4(.211324865405187,.366025403784439,-.577350269189626,.024390243902439);highp vec2 i=floor(v+dot(v,C.yy));highp vec2 x0=v-i+dot(i,C.xx);highp vec2 i1=x0.x>x0.y?vec2(1.,0.):vec2(0.,1.);highp vec4 x12=x0.xyxy+C.xxzz;x12.xy-=i1;i=mod289(i);highp vec3 p =permute(permute(i.y+vec3(0.,i1.y,1.))+i.x+vec3(0.,i1.x,1.));highp vec3 m=max(.5-vec3(dot(x0,x0),dot(x12.xy,x12.xy),dot(x12.zw,x12.zw)),0.);m=m*m;m=m*m;highp vec3 x =2.*fract(p*C.www)-1.;highp vec3 h=abs(x)-.5;highp vec3 ox=round(x);highp vec3 a0=x-ox;m*=inversesqrt(a0*a0+h*h);highp vec3 g;g.x=a0.x*x0.x+h.x*x0.y;g.yz=a0.yz*x12.xz+h.yz*x12.yw;return 100.*dot(m,g);}


highp float gcl(highp vec2 x,int octaves) {
	highp float v = 0.0;
	highp float a = 0.5;
	highp vec2 shift = vec2(1.);
	// Rotate to reduce axial bias
    mat2 rot = mat2(cos(1.), sin(1.), -sin(0.6), cos(0.6));
	for (int i = 0; i < octaves; ++i) {
		v += a * cloudnoise(x);
		x = rot * x * 2.5 + shift;
		a *= 0.35;
	}
	return v;
}