// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

//made by Glin

#include "fragmentVersionCentroid.h"

#if __VERSION__ >= 300
	#ifndef BYPASS_PIXEL_SHADER
		#if defined(TEXEL_AA) && defined(TEXEL_AA_FEATURE)
			_centroid in highp vec2 uv0;
			_centroid in highp vec2 uv1;
		#else
			_centroid in vec2 uv0;
			_centroid in vec2 uv1;
		#endif
	#endif
#else
	#ifndef BYPASS_PIXEL_SHADER
		￼varying vec2 uv0;
		varying vec2 uv1;
	#endif
#endif

#ifdef GL_FRAGMENT_PRECISION_HIGH
#define Hme highp
#else
#define Hme mediump
#endif

varying vec4 color;
varying highp vec3 p;
varying highp vec3 wp;
varying highp vec2 pw;
varying highp vec3 cp;
varying float water_f;

#ifdef FOG
varying vec4 fogColor;
#endif

#include "uniformShaderConstants.h"
#include "util.h"
#include "g_setting.h"
#include "g_noise.h"

uniform vec2 FOG_CONTROL;
uniform vec4 FOG_COLOR;
uniform float RENDER_DISTANCE;
uniform Hme float TOTAL_REAL_WORLD_TIME;

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;
LAYOUT_BINDING(1) uniform sampler2D TEXTURE_1;
LAYOUT_BINDING(2) uniform sampler2D TEXTURE_2;

#define rdc RENDER_DISTANCE
#define lmc uv1
#define fcl FOG_COLOR
#define fgct FOG_CONTROL

#define surface(a) normalize(cross(dFdx(a),dFdy(a)))
#define bump(a) texture2D(TEXTURE_0,uv0+a,0.00000001)
#define w(a,b) wp.a/wp.b

bool night_factor(){
if(FOG_COLOR.r<0.15 && FOG_COLOR.g<0.15){
return true;
}else{
return false;
}}

bool dusk_factor(){
if(FOG_COLOR.r*1.0>FOG_COLOR.b){
return true;
}else{
return false;
}}

bool nether_factor(){
if(FOG_COLOR.r>FOG_COLOR.b && 
FOG_COLOR.r<0.5 && FOG_COLOR.b<0.2){
return true;
}else{
return false;
}}

bool unwa(){
if(FOG_CONTROL.x==0.0 && FOG_COLOR.b > FOG_COLOR.r){
return true;
}else{
return false;
}}

bool notPlant(){ 
if(color.a !=0.){
return true;
}else{
return false;
}}

bool end_(){
if(FOG_COLOR.r > FOG_COLOR.g && FOG_COLOR.b > FOG_COLOR.g && FOG_COLOR.b > FOG_COLOR.r && FOG_COLOR.r < 0.05 && FOG_COLOR.b < 0.05 && FOG_COLOR.g < 0.05){
return true;
}else{
return false;
}}



bool glowingblock(){
if(texture2D(TEXTURE_0,uv0).a<0.05){
return true;
}else{
return false;
}}//toumeido 1%

bool sunrefblock(){
if(texture2D(TEXTURE_0,uv0).a<0.3&&texture2D(TEXTURE_0,uv0).a>0.05){
return true;
}else{
return false;
}}//toumeido 20%

#ifndef BYPASS_PIXEL_SHADER

const vec3 watc = vec3(.1,.6,.7);
//const vec3 toch = vec3(0.9,-0.3,-0.8);
//const vec3 toch2 = vec3(1.4,0.9,0.);
//const vec3 toch3 = vec3(0.7,0,-0.3);
const vec3 toch =vec3(0.9,-0.3,-1.1);
const vec3 toch2 = vec3(1.6,0.9,0.);
const vec3 toch3 = vec3(0.9,0.2,-0.3);
const vec3 s1 = vec3(0.7,-0.35,-0.5);
const vec3 s2 = vec3(1.3,0.8,0.);
const vec3 s3 = vec3(0.5,0,-0.3);
const vec3 unch = vec3(-0.5,-0.2,1.5);
const vec3 unch2 = vec3(0.,-0.4,.1);
const vec3 unch3 = vec3(-1.5,-0.4,1.5);
const vec3 niclr=vec3(0.8);

vec3 blockpos(highp vec3 p){
vec3 block_surface=surface(p);
return block_surface;
}

float Getnether(vec2 ft){
float nether_=ft.x/ft.y;
float final=step(0.1,nether_)-step(0.12,nether_);
return final;
}

float Getunwa(vec2 ft,vec4 fc){
float unwa=smt(.13,.12,ft.x);
float clrf=ax(step(fc.r,0.),step(fc.g,0.));
return unwa*clrf;
}

float global_lightning(float wtime,float wet_,vec2 lmc){
float GGRSlightningsystem = smt(pow(wtime,6.0)*(1.-wet_)*pow(lmc.y,5.0),1.,pow(lmc.x,2.5));
return GGRSlightningsystem;
}

vec2 rem_torch(vec2 lmc){
float reduce_light=smoothstep(lightning_strength,1.,lmc.x);
vec2 smalllight=vec2(clamp(0.,1.,0.1+reduce_light),lmc.y);
return smalllight;
}

highp float sun(highp vec2 p,highp float blur,highp float sl){
highp float light = length(p);
highp float cc = smoothstep(sl,sl-blur,light);
return cc;
}

vec3 GGRSmapping_tex(const vec3 x) {
    const float a = 2.51*3.3;
    const float b = 0.03*0.1;
    const float c = 2.43*2.1;
    const float d = 0.59*1.3;
    const float e = 0.14*sunlight_contrast;
    return ((x * (a * x + b)) / (x * (c * x + d ) + e));
}

vec3 lol(const vec3 color) {
	vec3 x = ax(vec3(0.0), color - 0.004);
	return (x * (6.2 * x + 0.5)) / (x * (6.2 * x + 1.7) + 0.06);
}

vec3 worldmap(in vec3 pvr,vec2 fc,vec4 fcl,float rain,float dusk_f,float nolight,float wtime){
vec3 clr=vec3(World_R,World_G,World_B);vec3 un_cl=vec3(0.1,0.55,0.75);vec3 wetclr=vec3(-0.15,-0.15,-0.05);vec3 dusk_clr=vec3(-0.01,-0.02,-0.05);vec3 hell=vec3(0.9,0.8,0.7);
vec3 endclr=vec3(.9,.9,1.3);
vec3 worldcoloring=ix(ix(ix(clr,un_cl,Getunwa(fc,fcl)),hell,Getnether(fc)),endclr,float(end_()));
pvr.rgb=pvr.rgb*worldcoloring;
pvr.rgb+=ix(ix(vec3(0),wetclr,rain),dusk_clr,dusk_f);
return pvr;
}

vec4 nightmap(in vec4 pvr,vec4 n_cl,vec2 lmc,vec2 ft,vec4 fc){
n_cl.rgb*=pow(n_cl.rgb,1.0-niclr);
pvr*=ix(vec4(1),ix(vec4(1),ix(vec4(1),ix(vec4(1),n_cl,smt(0.8,0.9,lmc.y)),(1.-Getunwa(ft,fc))),(1.-Getnether(ft))),float(!(end_())));
return pvr;
}

vec3 watermap(in vec3 pvr,float outdoor,float nightf,float waterf,float wet_,vec2 lmc){
vec3 based=vec3(0);
vec3 watcN=vec3(0);
float nights=smoothstep(1.,0.2,nightf);
pvr.rgb*=ix(vec3(1),based,waterf);
//pvr.rgb+=ix(vec3(0),watc*global_lightning(nightf,wet_,lmc),waterf)
pvr.rgb+=ix(vec3(0),ix(watc,watcN,nights),waterf)*smt(0.8,0.9,outdoor);
return pvr;
}

vec4 water_visible(in vec4 pvr,float rd,highp vec3 wp,highp float waterf,float nights){
highp float v_pos=smt(0.,rd*1.5,length(-wp*10.));
float visible_near=ix(0.7,0.95,nights);
float visible_=ix(0.8,0.9,nights);
pvr.a*=ix(1.,clamp(v_pos,visible_near,1.0),waterf);
pvr.a*=ix(1.,visible_,waterf);
return pvr;
}

vec3 illumination_(in vec3 pvr,Hme float t,vec4 fcl,vec2 fgc,float wtime,float wet_,vec2 lmc){
vec3 torchcolor=ix(toch,toch2,toch3);vec3 endLig=vec3(0.2,-0.2,1);vec3 unwaLight = ix(unch,unch2,unch3);vec3 space=ix(s1,s2,s3);
vec3 lightcolor=ix(ix(ix(torchcolor,endLig,Getunwa(fgc,fcl)),endLig,float(fcl.r > fcl.g && fcl
.b > fcl.g && fcl.b > fcl.r && fcl.r < 0.05 && fcl.b < 0.05 && fcl.g < 0.05)),torchcolor,Getnether(fgc));

float bl=sin(t*2.3+(gnoise(vec2(t*0.9,t*0.9))));
pvr.rgb+=pvr.rgb*lightcolor*global_lightning(wtime,wet_,lmc);
return pvr;
}

vec3 composite(in vec3 pvr,float outdoor,float uv1x,highp vec3 p,float waterf,float rf,vec4 fc,vec2 fgc,vec2 lmc,float wtime,float d_f,float df,vec4 clr){
vec3 fr=fract(p);
float slab_det=step(fract(p.y),0.5);
float shadowtex =ix(smt(shadow_size_start,shadow_size_end,outdoor),smt(0.875,0.865,outdoor),float(clr.a==0.));

float notindoor=smt(0.9,1.,outdoor);
highp float newshadowpos=smt(1.,0.,-blockpos(p).y);
highp float place=ax(0., ax(smt(0.,1.,-blockpos(p).x),smt(0.,1.,blockpos(p).x)));
highp float xpos_=smt(0.,1.,-blockpos(p).x);
highp float xpos=smt(0.,1.,blockpos(p).x);
highp float direct=ax(0.,blockpos(p).z);
//normal shadow
pvr.rgb*=ix(vec3(1),ix(vec3(1),ix(vec3(1),ix(vec3(1),ix(vec3(s_r,s_g,s_b),vec3(1),pow(global_lightning(wtime,rf,lmc),1.)),shadowtex),newshadowpos),(1.-Getunwa(fgc,fc))),(1.-rf));

return pvr;
}

vec3 composite_(in vec3 pvr,float outdoor,float uv1x,highp vec3 p,float waterf,float rf,vec4 fc,vec2 fgc,vec2 lmc,float wtime,float d_f,float df,vec4 clr){
float notindoor=smt(0.8,0.9,outdoor);
highp float newshadowpos=smt(1.,0.,-blockpos(p).y);
highp float place=ax(0.,ax( ax(0.,smt(0.,1.,-blockpos(p).z) ),ax(0., ax(smt(0.,1.,-blockpos(p).x),smt(0.,1.,blockpos(p).x))) ));
highp float direct=ax(0.,smt(0.,1.,blockpos(p).z));

pvr.rgb*=ix(vec3(1),ix(vec3(1),ix(vec3(1),ix(vec3(1),ix(vec3(s_r,s_g,s_b),vec3(1),pow(global_lightning(wtime,rf,lmc),1.)),notindoor),place),(1.-Getunwa(fgc,fc))),(1.-rf));//side surface shadow
pvr.rgb*=ix(vec3(1),ix(vec3(1),ix(vec3(1),ix(vec3(s_r,s_g,s_b)*0.8,vec3(1),pow(global_lightning(wtime,rf,lmc),1.)),smt(0.,1.,-blockpos(p).y)),(1.-Getunwa(fgc,fc))),(1.-rf));

vec3 directcolor=ix(ix(vec3(1),vec3(2.4,1.5,0.2),d_f),vec3(s_r,s_g,s_b)*0.3,(1.-notindoor));

pvr.rgb*=ix(vec3(1),ix(vec3(1),ix(vec3(1),ix(vec3(1),ix(directcolor,vec3(1),pow(global_lightning(wtime,rf,lmc),1.)),notindoor),direct),(1.-Getunwa(fgc,fc))),(1.-rf));
return pvr;
}

vec3 shadowx_w(in vec3 pvr,float outdoor,float uv1x,highp vec3 p,float waterf,float rf,vec4 fc,vec2 fgc,vec4 clr){
highp float Nshadow = smoothstep(shadow_size_start,shadow_size_end,outdoor);
highp float unmen=ax(0.,ax(blockpos(p).z,blockpos(p).y));
if(clr.b!=clr.r){
pvr.rgb*=ix(vec3(1),ix(vec3(1),ix(vec3(1),ix(vec3(1),ix(vec3(1),ix(vec3_(-0.45,-0.35),vec3(1.),pow(uv1x,2.5)),Nshadow),unmen),(1.-smt(.13,.12,fgc.x))),waterf),(1.-rf));}
return pvr;
}
//- must be "highp vec3 p". not "vec3 p".
vec3 side_shd_a(in vec3 pvr,vec2 lmc,highp vec3 p,float wtime,float rf,vec2 fgc,vec4 fc){
highp float sunPos=smoothstep(.0,.1,saturate(-blockpos(p).z));
pvr.rgb*=ix(vec3(1),ix(vec3(1),ix(vec3(1),ix(vec3(s_r,s_g,s_b),vec3(1),pow(global_lightning(wtime,rf,lmc),1.)),sunPos),(1.-Getunwa(fgc,fc))),(1.-rf));
return pvr;
}

vec3 side_plants(in vec3 pvr,vec2 lmc,highp vec3 p,float wtime,float rf,vec2 fgc,vec4 fc){
highp float shdpos=ax(0.,ax(blockpos(p).z,blockpos(p).y));
highp float p_pos= ax(0., ax(ax(0.,ax(0.,ax(-blockpos(p).x,blockpos(p).x))),ax(0.,ax(0.,ax(-blockpos(p).z,-blockpos(p).y)))));
pvr.rgb*=ix(vec3(1),ix(vec3(1),ix(vec3(1),ix(vec3(s_r,s_g,s_b),vec3(1),pow(global_lightning(wtime,rf,lmc),1.)),p_pos),(1.-Getunwa(fgc,fc))),(1.-rf));
return pvr;
}

vec3 GGRSfog(in vec3 pvr,vec4 fc,float rd,highp vec3 wp,float rain_f,float dusk_f,float waterf,vec2 fgc){
vec3 normalfog=vec3(day_R,day_G,day_B);vec3 duskf=vec3(1,0.9,0.2);vec3 netherfog=vec3(0.7,0.3,0.1);vec3 unfog=vec3(0,0.4,0.5);vec3 weting=vec3(1.5);
vec3 fog_frag=ix(ix(ix(ix(normalfog,weting,rain_f),unfog,Getunwa(fgc,fc)),duskf,dusk_f),netherfog,Getnether(fgc));
float nomd=1.;float duskd=1.;float netherd=1.0;float unfd=0.6;float wetd=0.2;float days=0.3;
float f_dis=ix(ix(ix(ix(days,wetd,rain_f),unfd,Getunwa(fgc,fc)),duskd,dusk_f),netherd,Getnether(fgc));
float w_nomd=1.;float w_wetd=0.8;float w_dud=0.8;float w_day=0.2;float w_ned=0.3;
float w_dis=ix(ix(ix(ix(w_day,w_wetd,rain_f),w_wetd,Getunwa(fgc,fc)),w_dud,dusk_f),w_wetd,Getnether(fgc));
pvr.rgb=ix(pvr.rgb,fc.rgb*fog_frag,smoothstep(0.0,rd*f_dis,length(-wp*w_dis)));
return pvr;
}

vec3 puddles(in vec3 pvr,highp vec3 p,float rain,float outdoors,highp vec3 wp,float rd){
highp float outdoor=smoothstep(shadow_size_end,shadow_size_start,outdoors);
highp float pdle = cloudnoise(p.xz*0.5);
pdle*=blockpos(p).y;
pdle=saturate(clamp(pdle,0.,0.5));
pvr.rgb=ix(pvr.rgb,pdle*vec3(0.4),rain);
return pvr;
}

vec3 under_caustic(in vec3 pvr,highp vec3 p,Hme float t,vec4 fc,vec2 fgc,float waterf,float lmy){
highp vec3 mp=mod(p.xyz,16.);
highp float unwave = tan(gnoise(vec2(t*1.+mp.x*0.8+mp.x*0.6+mp.z*0.5+mp.z*0.4, t*1.07+mp.z*0.8+mp.x*0.5+mp.z*0.56+mp.x*0.4)));
pvr.rgb+=ix(vec3(0),ix(vec3(0),(abs(unwave)*vec3(0.1)),Getunwa(fgc,fc)),(1.-Getnether(fgc)));
return pvr;
}

vec4 newwater_surface(in vec4 pvr,highp vec3 p,Hme float t,highp vec3 wp,highp float waterf,float lmy){
highp vec3 mp=mod(p.xyz,16.);
mp.xz*=vec2(0.9,0.6);
float outdoor=smoothstep(.8,0.9,lmy);
pvr+=ix(vec4(0),abs(cos(gnoise(vec2(t*1.3+mp.x*0.6+mp.x*0.3+mp.z*0.3, t*1.27+mp.z*0.4+mp.x*0.5+mp.z*0.26+mp.x*0.2)))*vec4(0.15))*outdoor,waterf);
return pvr;
}

highp vec4 clreflection(in vec4 pvr,highp vec3 wp,Hme float t,highp vec3 p,float waterf,float lm){
highp float cloud_rf=gnoise(wp.xz*0.01);
pvr+=ix(vec4(0),ix(vec4(0),abs(cloud_rf)*vec4(0.1),smt(0.5,1.,lm)),waterf);
return pvr;
}

vec3 watersunref(in vec3 pvr,float rd,highp vec3 wp,float waterf,float dusk,float sdusk,float nights,vec4 tex){
highp vec2 sunpos=reflect(wp.xz,vec2(1.,length(tex)));
//vec3 sunC=saturate(1.-length(-wp.z*10.0)/rd*1.5)*vec3(2.,1.8,0.2)*length(-wp.x*3.)/rd*1.;
//pvr.rgb+=ix(vec3(0),ix(vec3(0),sunC,waterf),dusk);
highp vec2 sunposition=wp.xz;
float sunduskpos=ix(ix(-10.,0.,sdusk),0.,nights);
sunposition+=vec2(-3.,0.);
sunposition*=vec2(0.6,1.);
//highp float sunshape=sun(vec2(sunposition.x,sunposition.z*0.3),0.3,1.1);
//reflect(sunposition,vec2(0.,length(texture2D(TEXTURE_0,uv0))))
//pvr.rgb+=ix(vec3(0),ix(vec3(0),ix(vec3(0),ix(vec3(0),ix(vec3(0),vec3(2,1.75,0.1),sun(reflect(normalize(sunposition),vec2(1.3,length(tex)*1.2)),0.5,3.0)),step(shadow_size_end,lmc.y)),smt(0.,1.,blockpos(p).y)),dusk),waterf);

highp vec2 sunrise=wp.xz;
sunrise+=vec2(3.,0.);
sunrise*=vec2(0.6,1.);

//pvr.rgb+=ix(vec3(0),ix(vec3(0),ix(vec3(0),ix(vec3(0),ix(vec3(0),vec3(2,1.75,0.1),sun(saturate(reflect(normalize(sunrise),vec2(-1.3,length(tex)*1.2))),0.5,3.0)),step(shadow_size_end,lmc.y)),smt(0.,1.,blockpos(p).y)),dusk),waterf);

vec3 sunC=saturate(wp.z*2.5/rd*2.)*vec3(2,1.75,0.1)*saturate(-wp.x*2.5/rd*0.5);//*(1.-length(-wp.y)/rd*1.5);
vec3 sunB=saturate(wp.z*2.5/rd*0.5)*vec3(2,1.75,0.1)*saturate(wp.x*2.5/rd*1.5);
pvr.rgb+=ix(vec3(0),ix(vec3(0),sunC*2.,waterf),dusk);
pvr.rgb+=ix(vec3(0),ix(vec3(0),sunB*2.,waterf),dusk);

return pvr;
}

vec3 vig(in vec3 pvr,highp vec3 cp){
highp float scr =1.-ax(.0,ax(.0,length(cp.xy))-0.6); 
pvr.rgb*=scr;
return pvr;
}

vec3 fog_grad(in vec3 pvr,highp vec3 wp,float rd,vec2 lm,float nol,vec4 fc,vec2 fl){
float f_wa=length(wp)/rd*0.5;
float f_wa2=length(wp)/rd;
pvr.rgb+=ix(0.,ix(0.,clamp(f_wa2*7.,0.,0.5),Getunwa(fl,fc)),(1.-Getnether(fl)));
pvr.rgb+=ix(0.,ix(0.,ix(0.,ix(0.,saturate(clamp(f_wa*3.,0.,0.7)),(1.-lm.y)),nol),(1.-Getunwa(fl,fc))),(1.-Getnether(fl)));
return pvr;
}

vec2 underwater_alwayslit(vec2 lmc,highp vec3 wp,float rd,vec2 ft,vec4 fc){
vec2 lit=lmc;
highp float distance=length(-wp)/rd*1.5;
lit.x=ix(1.,ix(1.,lmc.x,distance),Getunwa(ft,fc));
return lit;
}

vec3 godray(in vec3 pvr,highp vec3 wp,highp vec2 ppp,float sun){
wp.x+=2.;
highp float beam = cloudnoise(vec2(atan(w(y,z)))/atan(0.15));
highp float pp = length(ppp)/10.0;
highp float ww = length(wp.zy)/5.0;
pvr.rgb=ix(pvr.rgb, vec3(2),beam*pp*ww*vec3(1.1,1.1,0.1)*sun);
return pvr;
}

vec4 glowingore(in vec4 pvr,vec4 uv,highp vec3 wp,float rd,vec2 lmc,float nightf){
highp float v_pos=(length(-wp*dev_dis)/rd*dev_rd);
vec4 colorpos=ix( ix(vec4(6),vec4(1),smt(0.5,1.,lmc.y)) , vec4(6) , nightf );
if(glowingblock())pvr*=ix(vec4(0),colorpos,(1.-v_pos));
return pvr;
}

vec4 fake_gi(in vec4 pvr,vec4 uv,highp vec3 wp,float rd,vec2 lmc,float nightf){
highp float v_pos=(length(-wp*dev_dis)/rd*dev_rd);
vec4 colorpos=ix( ix( ix(vec4(5),vec4(0.8),smt(0.5,1.,lmc.y)) , vec4(5) , nightf ) , vec4(1), lmc.x );
if(sunrefblock())pvr*=ix(vec4(0),colorpos,(1.-v_pos));
return pvr;
}

vec3 sunreflection(in vec3 pvr,highp vec3 wp,vec2 lmc,float rd,vec4 tex,float dusk){
highp float v_pos=(length(-wp*dev_dis)/rd*dev_rd);
highp vec2 spos=wp.xz;
spos+=vec2(0.,-4.);
spos*=0.8;
if(sunrefblock())pvr.rgb+=ix(vec3(0),ix(vec3(0),ix(vec3(0),ix(vec3(0),ix( vec3(0),vec3(1),sun( spos,0.5,0.9) ),smt(0.5,1.,lmc.y)),(1.-v_pos)),smt(0.,1.,blockpos(p).y)),(1.-dusk));
return pvr;
}


#endif

void main()
{
#ifdef BYPASS_PIXEL_SHADER
	gl_FragColor = vec4(0);
	return;
#else 

#if USE_TEXEL_AA
	vec4 powervr = texture2D_AA(TEXTURE_0, uv0);
#else
	vec4 powervr = texture2D(TEXTURE_0, uv0);
#endif

Hme float t = TOTAL_REAL_WORLD_TIME;

float wtime = texture2D(TEXTURE_1, vec2(0,1)).r;
float cave = smoothstep(wtime * lmc.y, 1.0, lmc.x);
float lighter=ix(ix(lmc.x,0.0,wtime),lmc.x,cave);
float nolight = (1.-lighter);
float n_l=(1.-lmc.x);
float wet_ =smoothstep(0.5,0.1,fgct.x)*(1.-Getunwa(fgct,fcl))*lmc.y;
float dusk=min(smoothstep(0.4,0.5,wtime),smoothstep(1.,0.7,wtime))*(1.-wet_)*float(!(night_factor()))*lmc.y;
float duskset=saturate((fcl.r-0.1)-fcl.b);
float night_f=smt(1.,0.2,wtime);
float sundusk=min(smoothstep(.33,.5,wtime),smoothstep(1.,0.6,wtime))*(1.-wet_)*float(!(night_factor()));
vec4 night_tex=texture2D(TEXTURE_1, lmc);
highp vec3 frp=fract(p);
vec4 tex=texture2D(TEXTURE_0, uv0);

bool water_refa=(color.b>color.r||color.b>color.g);
bool grass=(color.g > (color.b + color.r) / 2.0*1.2 ||color.b > (color.g + color.r) / 2.0*1.2 || color.g<color.r);
bool grass2=(color.r != color.g||color.b!=color.g);

	#if VIGNETTE == 1
powervr.rgb=vig(powervr.rgb,cp);
	#endif
	#if BLOCK_SHADOW == 1
powervr.rgb=composite(powervr.rgb,lmc.y,lmc.x,p,water_f,wet_,fcl,fgct,lmc,wtime,dusk,duskset,color);
#if !defined(ALPHA_TEST)
powervr.rgb=composite_(powervr.rgb,lmc.y,lmc.x,p,water_f,wet_,fcl,fgct,lmc,wtime,dusk,duskset,color);
#endif
	#endif
#if defined(ALPHA_TEST)
	#if PLANT_SIDE_SHADOW == 1
if(color.a==0.)powervr.rgb=side_plants(powervr.rgb,lmc,p,wtime,wet_,fgct,fcl);
	#endif
#endif
#ifdef SEASONS_FAR
	powervr.a = 1.0;
#endif

#if USE_ALPHA_TEST
	#ifdef ALPHA_TO_COVERAGE
	#define ALPHA_THRESHOLD 0.05
	#else
	#define ALPHA_THRESHOLD 0.5
	#endif
	if(powervr.a < ALPHA_THRESHOLD)
    discard;
#endif

vec4 inColor = color;

#if defined(BLEND)
	powervr.a *= inColor.a;
#endif

	#if B_SUN_REFLECTION == 1
powervr.rgb=sunreflection(powervr.rgb,wp,lmc,rdc,tex,dusk);
	#endif
#if !defined(ALWAYS_LIT)
#if !defined(BLEND)
	#if B_GLOWING_ORES == 1
powervr=glowingore(powervr,tex,wp,rdc,lmc,night_f);
	#endif
#endif
powervr*=texture2D(TEXTURE_1,rem_torch(lmc));

powervr=nightmap(powervr,night_tex,lmc,fgct,fcl);
#endif

	#if ENABLE_TORCH_LIGHTNING == 1
powervr.rgb=illumination_(powervr.rgb,t,fcl,fgct,wtime,wet_,lmc);
	#endif

#if !defined(SEASONS)
	#if !USE_ALPHA_TEST && !defined(BLEND)
		powervr.a = inColor.a;
	#endif
	#ifdef dev_white_world
powervr=inColor;
	#endif

if(grass==true){
powervr.rgb*=ix(normalize(inColor.rgb),inColor.rgb,0.4);
}else{
if(color.a ==0.){
powervr.rgb*=inColor.rgb;}else{
powervr.rgb*=sqrt(inColor.rgb);}
}
#else
     vec2 uv = inColor.xy;
	powervr.rgb *= ix(vec3(1.0,1.0,1.0), texture2D( TEXTURE_2, uv).rgb*2.0, inColor.b);
	powervr.rgb *= inColor.aaa;
	powervr.a = 1.0;	
#endif
	
	#if WORLD_TONE == 1
powervr.rgb=GGRSmapping_tex(powervr.rgb);
	#endif

	#if WORLD_COLORING == 1
powervr.rgb=worldmap(powervr.rgb,fgct,fcl,wet_,dusk,n_l,wtime);
	#endif

#if !defined(ALPHA_TEST)
	#if CAVE_FOG == 1
powervr.rgb=fog_grad(powervr.rgb,wp,rdc,lmc,nolight,fcl,fgct);
	#endif
powervr.rgb=watermap(powervr.rgb,lmc.y,wtime,water_f,wet_,lmc);
powervr=water_visible(powervr,rdc,wp,water_f,night_f);
powervr.rgb=shadowx_w(powervr.rgb,lmc.y,lmc.x,p,water_f,wet_,fcl,fgct,color);
	#if SUN_REFLECTION == 1
powervr.rgb=watersunref(powervr.rgb,rdc,wp,water_f,duskset,sundusk,night_f,tex);
	#endif
	#if WATER_SURFACE_CAUSTIC == 1
powervr=newwater_surface(powervr,p,t,wp,water_f,lmc.y);
	#endif
	#if CLOUD_REFLECTION == 1
powervr=clreflection(powervr,wp,t,p,water_f,lmc.y);
	#endif
	#if UNDERWATER_CAUSTIC == 1
powervr.rgb=under_caustic(powervr.rgb,p,t,fcl,fgct,water_f,lmc.y);
	#endif
#endif
	#if FOGS == 1
powervr.rgb=GGRSfog(powervr.rgb,fcl,rdc,wp,wet_,dusk,water_f,fgct);
	#endif
	
gl_FragColor = powervr;
	
#endif // BYPASS_PIXEL_SHADER
}
